
var System = require("pid-system");
var request = require("request");


module.exports = async function(){
  var [returnPid, meta, message, options] = await this.receive();
options = options || {};
meta = meta || {};
var {errorCodes, returnResp} = options;
errorCodes = errorCodes || [];

var requestOpts = {};
for(var i in meta){
  requestOpts[i] = meta[i];
}
if(meta.contentType === "application/json" || (meta.headers && meta.headers["Content-Type"] === "application/json")){
  requestOpts.json = message;
} else {
  requestOpts.body = message;
}

await new Promise((res, rej) => {
  request.post(requestOpts, function(err, resp, body){
    var respMessage = [];
    if(err){
      respMessage.push("ERR");
      respMessage.push(err);
      respMessage.push(body);
      if(returnResp){
        respMessage.push(resp);
      }
      returnPid.send(respMessage);
      res();
      return;
    }
    if(errorCodes.indexOf(resp.statusCode) >= 0){
      respMessage.push("ERR");
      respMessage.push(new Error(resp.statusCode));
      respMessage.push(body);
      if(returnResp){
        respMessage.push(resp);
      }
      returnPid.send(respMessage);
      res();
      return;
    }
    respMessage.push("OK");
    respMessage.push(body);
    if(returnResp){
        respMessage.push(resp);
    }
    returnPid.send(respMessage);
    res();
    return;
  });

});
  this.recurse(module.exports);

}